import Rank._
import Suit._
import HandVal._
//import scala.collection.immutable.TreeMap
object Poker {
  def main(args: Array[String]): Unit = {
    	println(new Hand("KH QH 2H 4H KH")) // expected: Flush
    	println(new Hand("2D QD JD 4D 2D")) // expected: Flush
    	println(new Hand("KH QH JH TH AH")) // expected: Straight Flush
        println(new Hand("3H 7S 5H 6D 4H")) // expected: Straight
        println(new Hand("4H 5S AH 3D 2H")) // expected: Straight (according to special rule: ace also counts as 'ONE')
        println(new Hand("TH QS TH TD TC")) // expected: Poker
        println(new Hand("2H QS 2H 2D QC")) // expected: Full House
        println(new Hand("2H QS 2H 2D KC")) // expected: Three of a Kind
        println(new Hand("5H QS 5H TD TC")) // expected: Two Pairs
        println(new Hand("3H 8S 5H 8D AC")) // expected: One Pair
        println(new Hand("3H 8S 5H KD AC")) // expected: High Card
        println(new Hand("4H 8S AH 3D 2H")) // expected: High Card; but almost a Straight with special rule that ace also counts as 'ONE'
        println("=======================================")
        println
        // test the sorting
        val hands = List (new Hand("3H 8S 5H KD AC"), new Hand("4H 8S AH 3D 2H"), 
            new Hand("2H QS 2H 2D QC"), new Hand("2C 2S QS 2D QC"))
        val sortedDescHands = hands.sortWith(_ > _)
        println("***********")
        println(sortedDescHands)
        val sortedAscHands = hands.sortWith(_ < _)
        println("***********")
        println(sortedAscHands)
  }
}